/*
   First test - just make the command buffer work
*/

#include <AccelStepper.h>
#include <elapsedMillis.h>

#define HALFSTEP 4
//motor derecha
#define motorPin1 4 //pin IN1 del driver ULN2003
#define motorPin2 5 // pin IN2 del driver ULN2003
#define motorPin3 6 // pin IN3 del driver ULN2003
#define motorPin4 7 // pin IN4 del driver ULN2003

//motor izquierda
#define motorPin5 8 // pin IN1 del driver ULN2003
#define motorPin6 9 // pin IN2 del driver ULN2003
#define motorPin7 10 //pin IN3 del driver ULN2003
#define motorPin8 11 //pin IN4 del driver ULN2003
// Define dos objetos de motor paso a paso
AccelStepper stepper1 (HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);
AccelStepper stepper2 (HALFSTEP, motorPin5, motorPin7, motorPin6, motorPin8);

elapsedMillis printTime;

#define READ_CMD 1
#define RUN_CMD 2
#define STOP_CMD 3

//PARAMETROS MATRIZ
char matriz [30];
int i = 0; //contador

//asignación de pines de entrada a los pulsadores

int Pizquierda = A5; //Pulsador giro izquierda
int Padelante = A4;
int Pderecha = A2;
int Patras = A1;
//int Pborra = A0;
int Pactiva = A3;

int state = READ_CMD;   // initial state

void setup () {
  Serial.begin(115200);
  //stepper1. setSpeed ( 600 );
  stepper1. setAcceleration ( 200 );//con aceleraciones superiores la rueda se atranca
  stepper1. setMaxSpeed ( 1000 );
  // stepper2. setSpeed (600 );
  stepper2. setAcceleration ( 200 );
  stepper2. setMaxSpeed ( 1000 );
  // 2048 pasos equivale a media vuelta

  // PULSADORES
  /* pinMode(Pizquierda,INPUT);
    pinMode(Padelante,INPUT);
    pinMode(Pderecha,INPUT);
    pinMode(Patras,INPUT);
    pinMode(Pborra,INPUT);
    pinMode(Pactiva,INPUT);*/
  pinMode(Pizquierda, INPUT_PULLUP);
  pinMode(Padelante, INPUT_PULLUP);
  pinMode(Pderecha, INPUT_PULLUP);
  pinMode(Patras, INPUT_PULLUP);
  //pinMode(Pborra, INPUT_PULLUP);
  pinMode(Pactiva, INPUT_PULLUP);
  // this just for testing
  matriz[0] = 'R';
  matriz[1] = 'A';
  matriz[2] = 'I';
  matriz[3] = 'D';
}

void loop () {
  int doneA, doneB;
  int cmd;
  //bucle matriz

/*  if (printTime >= 1000) {    // happens once per second
    Serial.println(state);
    printTime = 0;
   /* Serial.print("i=");
    Serial.println(i);
    Serial.print("x=");
    Serial.println(matriz[i]); // a efectos de visualización en el monitor serie
    
  }
  */
  
  switch (state) {
    case READ_CMD:
     // Serial.println("read");
     // Serial.print("i is ");
      //Serial.print(i);
      //Serial.print(" val: ");
      //Serial.println(matriz[i]);
      //delay(500);
      cmd = matriz[i++];
      switch (cmd)  // lee el valor de cada celda de la matríz o y lo envia al caso correspondiente
      {
        case 'A'://avanza
          ADelante();
          Serial.println("Ade called");
          state = RUN_CMD;
          break;

        case 'I':
          IZquierda();
          Serial.println("Izq called");
          state = RUN_CMD;
          break;

        case 'D':
          DErecha();
          Serial.println("Der called");
          state = RUN_CMD;
          break;

        case 'R':
          ATras();
          Serial.println("Atr called");
          state = RUN_CMD;
          break;
        default:
          Serial.println("no match");
          Serial.println("All Done!");
          state = STOP_CMD;       // null encountered, no more commands
          break;
      }
      break;
    case RUN_CMD:
     //Serial.println("run");
      doneA = !stepper1.run ();   // run() returns false when move is complete - so doneA will be true
      doneB = !stepper2.run ();
      if (doneA && doneB) {
        Serial.println("Next, please");
        state = READ_CMD;
      }
      break;
    case STOP_CMD:
      break;
    default:
      Serial.println("Bad Ending!!!");
      state = STOP_CMD;
      break;
  }
}

void  ADelante ()
{
  // if (stepper1.distanceToGo() == 0)
  {
    stepper1. move( 2048 );   //2048
    stepper2. move(- 2048 );   // -2048

  }
}
void  IZquierda ()
{

  // if (stepper1.distanceToGo() == 0)
  {
    stepper1. move (500 );   //500
    stepper2. move (500 );    //500
  }
}

void  ATras ()
{
  // if (stepper1.distanceToGo() == 0)
  {
   stepper1. move ( -2048 );  //-2048
   stepper2. move ( 2048);    //2048
  }
}

void  DErecha ()
{
  // if (stepper1.distanceToGo() == 0)
  {
    stepper1. move ( -500 );  //-500
    stepper2. move (- 500);    //-500
  }
}
